#ifndef POLYNOME_H
#define POLYNOME_H

#include "rationnel.h"

typedef unsigned short int usint;

using namespace std;

class Polynome{
 private:
  void normalise();
 protected:
  void affiche_puissance(ostream& os,usint i) const;
  void affiche_premier_monome(ostream& os,usint i) const;
  void affiche_monome(ostream& os,usint i) const;
  usint degree;
  Rationnel* coeffs;
 public:
  Polynome();// crée le polynome nul
  explicit Polynome(usint n);// crée le polynome X^n
  Polynome(const Polynome& P);
  Polynome& operator=(const Polynome& P);
  int get_degree() const; //return the degree of the polynome
  Rationnel operator()(const Rationnel& r) const;
  double operator()(double) const;
  Rationnel operator[](usint i) const;
  Rationnel& operator[](usint i);
  Polynome operator+(const Rationnel& r) const;
  Polynome operator+(const Polynome& P) const;
  Polynome operator-(const Rationnel& r) const;
  Polynome operator-() const;
  Polynome operator-(const Polynome& P) const;
  Polynome operator*(const Rationnel& r) const;
  Polynome operator/(const Rationnel& r) const;
  Polynome operator*(const Polynome& Q) const;
  friend Polynome operator+(const Rationnel& r,const Polynome& P);
  friend Polynome operator-(const Rationnel& r,const Polynome& P);
  friend Polynome operator*(const Rationnel& r,const Polynome& P);
  friend ostream& operator<<(ostream& os,const Polynome& P);
};

/*class Rationnel{
 protected:
  long int p,q;
  void normalise();
 public:
  Rationnel();// crée le rationnel 0
  Rationnel(long int p);// crée le rationnel p
  Rationnel(long int p,long int q);// crée le rationnel p/q si q>0
  Rationnel(const Rationnel& r);
  Rationnel& operator=(const Rationnel& r);
  Rationnel operator+(const Rationnel& r) const;// retourne le rationnel courant + r
  Rationnel operator-(const Rationnel& r) const;// retourne le rationnel courant - r
  Rationnel operator-() const;// retourne - le rationnel courant
  Rationnel operator*(const Rationnel& r) const;// retourne le rationnel courant * r
  Rationnel operator/(const Rationnel& r) const;// retourne le rationnel courant / r si r!=0
  bool operator==(const Rationnel& r) const;// teste si le rationnel courant est egal à r
  bool operator!=(const Rationnel& r) const;// teste si le rationnel courant est différent de r
  bool operator<(const Rationnel& r) const;// teste si le rationnel courant est < à r
  bool operator>(const Rationnel& r) const;// teste si le rationnel courant est > à r
  bool operator<=(const Rationnel& r) const;// teste si le rationnel courant est <= à r
  bool operator>=(const Rationnel& r) const;// teste si le rationnel courant est >= à r
  friend Rationnel operator+(const long int& a,const Rationnel& r);
  friend Rationnel operator-(const long int& a,const Rationnel& r);
  friend Rationnel operator*(const long int& a,const Rationnel& r);
  friend Rationnel operator/(const long int& a,const Rationnel& r);
  friend bool operator==(const long int& a,const Rationnel& r);
  friend bool operator!=(const long int& a,const Rationnel& r);
  friend bool operator<(const long int& a,const Rationnel& r);
  friend bool operator>(const long int& a,const Rationnel& r);
  friend bool operator<=(const long int& a,const Rationnel& r);
  friend bool operator>=(const long int& a,const Rationnel& r);
  friend ostream& operator<<(ostream& os,const Rationnel& r);
  };*/




#endif
