#ifndef RATIONNEL_H
#define RATIONNEL_H
#include <iostream>
#include <sstream>

using namespace std;

long int pgcd(long int a,long int b);

class Rationnel{
 protected:
  long int p,q;
  void normalise();
 public:
  Rationnel();// crée le rationnel 0
  Rationnel(long int p);// crée le rationnel p
  Rationnel(long int p,long int q);// crée le rationnel p/q si q>0
  Rationnel(const Rationnel& r);
  Rationnel& operator=(const Rationnel& r);
  Rationnel operator+(const Rationnel& r) const;// retourne le rationnel courant + r
  Rationnel operator-(const Rationnel& r) const;// retourne le rationnel courant - r
  Rationnel operator-() const;// retourne - le rationnel courant
  Rationnel operator*(const Rationnel& r) const;// retourne le rationnel courant * r
  Rationnel operator/(const Rationnel& r) const;// retourne le rationnel courant / r si r!=0
  bool operator==(const Rationnel& r) const;// teste si le rationnel courant est egal à r
  bool operator!=(const Rationnel& r) const;// teste si le rationnel courant est différent de r
  bool operator<(const Rationnel& r) const;// teste si le rationnel courant est < à r
  bool operator>(const Rationnel& r) const;// teste si le rationnel courant est > à r
  bool operator<=(const Rationnel& r) const;// teste si le rationnel courant est <= à r
  bool operator>=(const Rationnel& r) const;// teste si le rationnel courant est >= à r
  double to_double() const;
  friend Rationnel operator+(const long int& a,const Rationnel& r);
  friend Rationnel operator-(const long int& a,const Rationnel& r);
  friend Rationnel operator*(const long int& a,const Rationnel& r);
  friend Rationnel operator/(const long int& a,const Rationnel& r);
  friend bool operator==(const long int& a,const Rationnel& r);
  friend bool operator!=(const long int& a,const Rationnel& r);
  friend bool operator<(const long int& a,const Rationnel& r);
  friend bool operator>(const long int& a,const Rationnel& r);
  friend bool operator<=(const long int& a,const Rationnel& r);
  friend bool operator>=(const long int& a,const Rationnel& r);
  friend ostream& operator<<(ostream& os,const Rationnel& r);
};




#endif
